/* ---------------------------------------------------------- 
%   (C)1993,1994,1995 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
%   (C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
%       (Read COPYRIGHT-JIPDEC for detailed information.)
----------------------------------------------------------- */

#ifndef _KLIC_GOBJ_H_
#define _KLIC_GOBJ_H_

#include <klic/g_methtab.h>

/*
  macros which call methods
*/

#define method_table_of(obj) ((obj)->method_table)
#define generic_active_unify(obj, anothor, allocp) \
do{ \
  (allocp) = method_table_of(obj)->active_unify((obj), (anothor), (allocp)); \
}while(0)

#define generic_generate(obj, allocp) \
  (method_table_of(obj)->generate((obj), (allocp)))

/*** for Shared-memory KLIC system ***/
#define generic_shmcopy(obj) \
  (method_table_of(obj)->shmcopy(obj))

/**** header file for using data and functions defined in kernel ****/ 

/*
  datas for general utility with consumer object
*/

/****************
  suspension_reason

  shows result of the processing for consumer object.

  0: normal;
  1: GC request;
  other: the process is suspended. pointer of the reason of the prosess.
******************/
extern q suspension_reason;

/************
  rest_of_stream

  indicates the next hooked term. This variable is meaningful
  just `suspension_reason' is 0.

  0: normal;
  other: the next hooked term
**************/
extern q rest_of_stream;


extern q method_result;


#endif /* _KLIC_GOBJ_H_ */
